function deriv = dydt_hund08(t,statevar,Id)

% global F R T RTF ;
% global Acap Cm Vmyo VSR ;
% global Ko Nao Cao Ki Nai ;
% global GNa_ GK1_ GKr_ GKs_ GKp_ Gto_ GNab_ GCab_ ;
% global PCa PCaK Prel Pleak INaK_ ICahalf IpCa_ kNaCa Vup ;
% global eta ksat KmNa KmCa KmfCa KmK1 KmNai KmKo KmpCa Kmup ;
% global CMDNtot KmCMDN CSQNtot KmCSQN ;

global F R T RTF ;
global Acap Vmyo Vss VJSR VNSR ;
global Ko Nao Clo Cao ;

global KmCaMK 
global GNa_ dV_CaMK_max daj_CaMK_max GNaL_ dGNaL_CaMK_max KmCaMK_Na
global GK1_ GKr_ GKs_ pKNa GKp_ Gto_ 
global PCa PCab gamma_Cao gamma_Cai dtauf_max dtaufCa_max
global Kmto2 GClb_ CTKCl_ CTNaCl_ PCl 
global KmNa_NaK KmK_NaK INaK_ 
global kNaCa ksat eta KmNai KmNao KmCai KmCao KmCa_allo
global kappa_rel betatau Krel_inf dKrelinf_max Krel_tau 
global IpCa_ KmpCa Vup Kmup dKmPLB_CaMK_max Kleak CaNSR_max dJleak_CaMK_max 
global tau_diff tau_transfer 
global TRPNtot KmTRPN CMDNtot KmCMDN CSQNtot KmCSQN BSRtot KmBSR BSLtot KmBSL 
global CaMK0 KmCaM alpha_CaMK beta_CaMK

statevarcell = num2cell(statevar) ;

[V,Cai,Cass,CaNSR,CaJSR,Nai,Ki,Cli,m,h,j,hL, ...
  d,f,fCa,fCa2,xKr,xs1,xs2,ato,ito1,ito2,aa,Orel,CAMK_trap] = ...
  deal(statevarcell{:}) ;

% % CaMK

CAMK_bound=CaMK0*(1-CAMK_trap)/(1+KmCaM/Cass) ;
CAMK_a=CAMK_bound+CAMK_trap;

dCAMK_trap = alpha_CaMK*CAMK_a*CAMK_bound - beta_CaMK*CAMK_trap ;

% Reversal potentials
ENa = RTF*log(Nao/Nai) ;
EK = RTF*log(Ko/Ki) ;
EKs = RTF*log((Ko + pKNa*Nao)/(Ki + pKNa*Nai)) ;
ECa = 0.5*RTF*log(Cao/Cai) ;
ECl = -RTF*log(Clo/Cli) ;

%% compute ionic currents

% Na currents
INa = GNa_*m^3*h*j*(V - ENa) ;

dGNaL_CaMK = dGNaL_CaMK_max/((KmCaMK_Na/CAMK_a)^4 + 1) ;

INaL = (GNaL_+dGNaL_CaMK)*m^3*hL*(V - ENa) ;

% Ca currents

ICa_ = PCa*4*F/RTF*V* ...
  (gamma_Cai*Cass*exp(2*V/RTF) - gamma_Cao*Cao)/ ...
  (exp(2*V/RTF) - 1) ;
ICa = ICa_*d*f*fCa*fCa2 ;

ICab = PCab*4*V*F/RTF*(gamma_Cai*Cai*exp(2*V/RTF)- ...
  gamma_Cao*Cao)/(exp(2*V/RTF)-1) ;

IpCa = IpCa_*Cai/(Cai + KmpCa) ;

% % IK1
ak1 = 1.02/(1+exp(0.2385*(V-EK-59.215))) ;
bk1 = (0.49124*exp(0.08032*(V-EK+5.476))+exp(0.06175*(V-EK-594.31)))/...
    (1+exp(-0.5143*(V-EK+4.753))) ;
IK1 = GK1_*sqrt(Ko/5.4)*ak1/(ak1+bk1)*(V-EK) ;


% % IKr
RKr = 1/(exp((V+10)/15.4) + 1) ;
IKr = GKr_*sqrt(Ko/5.4)*xKr*RKr*(V - EK) ;

% % IKs
IKs = GKs_*(1+0.6/((3.8e-5/Cai)^(1.4)+1))*xs1*xs2*(V - EKs) ;

% % Ito
Rto = exp(V/300) ;
Ito = Gto_*ato^3*ito1*ito2*Rto*(V - EK) ;

% Chloride currents
CTKCl = CTKCl_*(EK-ECl)/((EK-ECl)+87.8251) ;
CTNaCl = CTNaCl_*(ENa-ECl)^4/( (ENa-ECl)^4 + 87.8251^4) ;

IClb = GClb_*(V - ECl) ;

Ito2 = aa*PCl*V*F/RTF*(Cli-Clo*exp(V/RTF))/(1-exp(V/RTF)) ;


Kp = 1/(1+exp((7.488-V)/5.98)) ;
IKp = GKp_*Kp*(V - EK) ;

% Pumps and transporters
sigma_NaK = (exp(Nao/67.3) - 1)/7 ; 
fNaK = 1/(1 + 0.1245*exp(-0.1*V/RTF) + 0.0365*sigma_NaK*exp(-V/RTF)) ;

INaK = INaK_*fNaK*Ko/(Ko + KmK_NaK)*(1 + (KmNa_NaK/Nai)^2)^-1 ;

% % INaK updated


num = kNaCa*(Nai^3*Cao*exp(eta*V/RTF)-Nao^3*Cai*exp((eta-1)*V/RTF)) ;
denom1 = 1+ksat*exp((eta-1)*V/RTF) ;
denom2 = KmCao*Nai^3+KmNao^3*Cai+KmNai^3*Cao*(1+Cai/KmCai) ;
denom3 = KmCai*Nao^3*(1+(Nai/KmNai)^3)+Nai^3*Cao+Nao^3*Cai ;
allo = 1/(1 + (KmCa_allo/(1.5*Cai))^2) ;
INCX_cyto = 0.8*allo*num/(denom1*(denom2+denom3)) ;

num = kNaCa*(Nai^3*Cao*exp(eta*V/RTF)-Nao^3*Cass*exp((eta-1)*V/RTF)) ;
denom1 = 1+ksat*exp((eta-1)*V/RTF) ;
denom2 = KmCao*Nai^3+KmNao^3*Cass+KmNai^3*Cao*(1+Cass/KmCai) ;
denom3 = KmCai*Nao^3*(1+(Nai/KmNai)^3)+Nai^3*Cao+Nao^3*Cass ;
allo = 1/(1 + (KmCa_allo/(1.5*Cass))^2) ;
INCX_ss = 0.2*allo*num/(denom1*(denom2+denom3)) ;

INCX = INCX_cyto + INCX_ss ;

Iion = INa + INaL + ICa + ICab + IpCa + IK1 + IKr + IKs + Ito + Ito2 + ...
  IKp + INaK + INCX  ;

%% compute rate constants to update gates

% % % Most CaMK-dependent processes have same Km (0.05)
% % % But Na current is different, need to define new variable
% % KmCaMK = 0.05 ;
% % KmCaMK_Na = 0.06 ;
dV_CaMK = dV_CaMK_max/((KmCaMK_Na/CAMK_a)^4 + 1) ;
daj_CaMK = daj_CaMK_max/((KmCaMK_Na/CAMK_a)^4 + 1) ;

% % 1) Na current
if (V-dV_CaMK) >= -40
    ah = 0.0;
    bh = 1/(0.13*(1+exp((V-dV_CaMK+10.66)/(-11.1)))) ;
    aj = 0.0;
    bj = 0.3*exp(-2.535e-7*(V-dV_CaMK))/(exp(-0.1*(V-dV_CaMK+32))+1) ;
else
    ah = 0.135*exp(-(80+V-dV_CaMK)/6.8) ;
    bh = 3.56*exp(0.079*(V-dV_CaMK)) + 3.1e5*exp(0.35*(V-dV_CaMK)) ;
    aj1 = -1.2714e5*exp(0.2444*(V-dV_CaMK)) ;
    aj2 = 3.474e-5*exp(-0.04391*(V-dV_CaMK)) ;
    aj3 = (V-dV_CaMK+37.78)/(exp(0.311*(V-dV_CaMK+79.23)) + 1) ;
    aj = (1 + daj_CaMK)*(aj1-aj2)*aj3 ;
    bj = 0.1212*exp(-0.01052*(V-dV_CaMK))/(exp(-0.1378*(V-dV_CaMK+40.14))+1) ;
end

am = 0.32*(V+47.13)/(1-exp(-0.1*(V+47.13))) ;
bm = 0.08*exp(-V/11) ;

dmdt = am - (am+bm)*m ;
dhdt = ah - (ah+bh)*h ;
djdt = aj - (aj+bj)*j ;

% m, h, j updated

% % 2) late Na current
hLinf = 1/(exp((V+91)/6.1) + 1) ;
tauhL = 600 ;

% m gate for late Na current the same
dhLdt = (hLinf - hL)/tauhL ;

% hL updated

% % % 2) Ca current
dinf=1/(1+exp(-(V-4)/6.74)) ;
taud=0.59+0.8*exp(0.052*(V+13))/(1+exp(0.132*(V+13))) ;

finf=0.7/(1+exp((V+17.12)/7)) + 0.3;

% This area here needs to be modified substantially

dtauf = dtauf_max*CAMK_a^5/(KmCaMK^5+CAMK_a^5) ;
tauf= 22 + 280*(exp(0.062*(V+28.3)))/(exp(0.25*(V+28.3)) + 1) +  ...
  dtauf ;

fCainf = 0.3/(1-ICa/0.05)+0.55/(1+Cass/0.002)+0.15;%
fCa2inf =1/(1-ICa/0.01) ;

dtaufCa = dtaufCa_max*CAMK_a^5/(KmCaMK^5+CAMK_a^5) ;
taufCa = dtaufCa + 0.5 + 1/(1+Cass/0.002) ;
taufCa2 = 100/(1+exp((-ICa-0.175)/0.04)) + 100 ;

dddt = (dinf - d)/taud ;
dfdt = (finf - f)/tauf ;

dfCadt = (fCainf - fCa)/taufCa ;
dfCa2dt = (fCa2inf - fCa2)/taufCa2 ;

xKrinf = 1/(1+exp(-(V+10.085)/4.25)) ;
tauxKr = 1/(6e-4*(V-1.7384)/(1-exp(-0.136*(V-1.7384)))...
    +3e-4*(V+38.3608)/(exp(0.1522*(V+38.3608))-1)) ;

dxKrdt = (xKrinf - xKr)/tauxKr ;

% xKr updated

xsinf = 1/(exp(-(V-10.5)/24.7)+1) ;

tauxs1 = 1/ ...
  ( 5.0824e-5*(V+18.5172)/(1-exp(-0.064*(V+18.5172)))+ ...
  4.8824e-4*(V+18.5172)/(exp(0.064*(V+18.5172))-1) ) ;
tauxs2 = 2*tauxs1 ;

dxs1dt = (xsinf - xs1)/tauxs1 ;
dxs2dt = (xsinf - xs2)/tauxs2 ;

% xs1 xs2 updated

atoinf = 1/(exp(-(V+3)/15) + 1) ;
tauato = 3.5*exp(-(V/30)^2) + 1.5 ;

aito1 = 0.03/(exp((V+60)/5)+1) ;
bito1 = 0.2*exp((V+25)/5)/(exp((V+25)/5)+1) ;

aito2 = 0.00225/(exp((V+60)/5)+1) ;
bito2 = 0.1*exp((V+25)/5)/(exp((V+25)/5)+1) ;

datodt = (atoinf-ato)/tauato ;
dito1dt = aito1 - (aito1+bito1)*ito1 ;
dito2dt = aito2 - (aito2+bito2)*ito2 ;

% ato ito1 ito2 updated

% second transient outward current
aainf = 1/(1.0+Kmto2/Cass) ;
tauaa = 1 ;

daadt = (aainf - aa)/tauaa ;

% aa updated

% % Intracellular Ca fluxes
% % SR Ca release, uptake, and leak
% 
% 

% % Release equations completely changed between 2004 and 2008
% % New equations follow Livshitz & Rudy

% % Note:  this value from Livshitz, not explicitly stated in Hund
% supplement

alpha_rel = kappa_rel*betatau ;
Jrel = Orel*(CaJSR - Cass) ;

dKrel_inf = dKrelinf_max/((KmCaMK/CAMK_a)^5 + 1) ;
Orelinf = alpha_rel*ICa/(((Krel_inf - dKrel_inf)/CaJSR)^10 + 1) ;
tauOrel = 5.25/(Krel_tau/CaJSR + 1) ;

dOreldt = -(Orelinf + Orel)/tauOrel ;

dKmPLB=dKmPLB_CaMK_max/((KmCaMK/CAMK_a)^5 + 1) ;
Jup = Vup*Cai/(Cai+Kmup-dKmPLB) ;

dJleak_CaMK = dJleak_CaMK_max/((KmCaMK/CAMK_a)^5 + 1) ;
Jleak = Kleak/CaNSR_max*(1 + dJleak_CaMK)*CaNSR ;

Jdiff = (Cass-Cai)/tau_diff ;
Jtr = (CaNSR-CaJSR)/tau_transfer ;

% % % Buffering factors for rapid buffering approximation

BJSR = (1 + CSQNtot*KmCSQN/(KmCSQN + CaJSR)^2)^-1 ;

Bi = 1/(1+ CMDNtot*KmCMDN/(Cai+KmCMDN)^2+ ...
  TRPNtot*KmTRPN/(Cai+KmTRPN)^2) ;

Bss = 1/(1+BSRtot*KmBSR/(Cass+KmBSR)^2+BSLtot*KmBSL/(Cass+KmBSL)^2) ;

% % % Derivatives for voltage and ionic concentrations
dVdt = -(Id + Iion) ;

dNai = -(INa + INaL + 3*INCX + 3*INaK)*Acap/(Vmyo*F) + CTNaCl ;
dKi = -(IKr + IKs + IK1 + IKp - 2*INaK + Ito + 0.5*Id)*Acap/(Vmyo*F) + CTKCl ;
dCli = (IClb + Ito2 + 0.5*Id)*Acap/(Vmyo*F) + CTNaCl + CTKCl ;

dCass = Bss*( Jrel*VJSR/Vss - Jdiff - (ICa - 2*INCX_ss)*Acap/(2*Vss*F) ) ;

dCai = Bi*( (Jleak - Jup)*VNSR/Vmyo + Jdiff*Vss/Vmyo - ...
  (ICab + IpCa - 2*INCX_cyto)*Acap/(2*Vmyo*F) ) ;

dCaJSR = BJSR*(Jtr - Jrel) ;
dCaNSR = Jup - Jleak - Jtr*VJSR/VNSR ;

deriv = [dVdt;dCai;dCass;dCaNSR;dCaJSR;dNai;dKi;dCli; ...
  dmdt;dhdt;djdt;dhLdt;dddt;dfdt;dfCadt;dfCa2dt; ... 
  dxKrdt;dxs1dt;dxs2dt;datodt;dito1dt;dito2dt;daadt; ...
  dOreldt;dCAMK_trap] ;

return


