
%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%
% % % Step 1:  Load in normal zone and border zone results
%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%

dex = 2 ;

load NZvTRS_many1

Yrow1=[Ynormal(dex,:)];

load NZvTRS_many2
Yrow2=[Yhyper(dex,:)];

load NZvTRS_many3
Yrow3=[Yhypo(dex,:)];

Yrowfinal=[Yrow1,Yrow2,Yrow3];

%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%
% % % Step 2:  Load in results for regression
%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%


% load hund_fixed_isokalemia_300
load hund_fixed_isokalemia

Y = [log(APD)',Vrest',Vpeak', log(Triang)', log(Ca_trans)', dVdtmax', log(CaSR_diastole)', peak_time', log(decay_time)', maxmin', minmax'] ;

clear aps
clear catransients
clear times
clear allparameters

clear APD
clear Vrest
clear Vpeak
clear Triang
clear Ca_trans
clear dVdtmax
clear CaSR_diastole
clear peak_time
clear decay_time
clear maxmin
clear minmax

% load hund_fixed_hyperkalemia_300
load hund_fixed_hyperkalemia
Y=[Y,log(APD)',Vrest',Vpeak', log(Triang)', log(Ca_trans)', dVdtmax', log(CaSR_diastole)', peak_time', log(decay_time)', maxmin', minmax'];
clear aps
clear catransients
clear times
clear allparameters

clear APD
clear Vrest
clear Vpeak
clear Triang
clear Ca_trans
clear dVdtmax
clear CaSR_diastole
clear peak_time
clear decay_time
clear maxmin
clear minmax

% load hund_fixed_hypokalemia_300
load hund_fixed_hypokalemia
Y=[Y,log(APD)',Vrest',Vpeak', log(Triang)', log(Ca_trans)', dVdtmax', log(CaSR_diastole)', peak_time', log(decay_time)', maxmin', minmax'];

clear aps
clear catransients
clear times

clear APD
clear Vrest
clear Vpeak
clear Triang
clear Ca_trans
clear dVdtmax
clear CaSR_diastole
clear peak_time
clear decay_time
clear maxmin
clear minmax

% allparameters=allparameters(:,1:300);
X = log(allparameters)' ;
% % % Get rid of CaMK


mu = mean(Y) ;
dev = std(Y) ;
% variations=300;
variations=500;
Ytestlow = ( Y < ones(variations,1)*(mu - 3*dev) ) ;
keep = find(~any(Ytestlow,2)) ;
Y = Y(keep,:) ;
X = X(keep,:) ;
variations = length(keep)

Ytesthigh = ( Y > ones(variations,1)*(mu + 3*dev) ) ;
keep = find(~any(Ytesthigh,2)) ;
Y = Y(keep,:) ;
X = X(keep,:) ;
variations = length(keep)

placeholder = X ;
X = Y ;
Y = placeholder ;
clear placeholder

muY=mean(X);
sigmaY=std(X);
Yrow_Z=(Yrowfinal-muY)./sigmaY ;

% % % Introducing Z-score cutoff does not seem to help
% cutoff = 100 ;
% gooddices = find(abs(Yrow_Z) < cutoff) ;
% Yrow_Z = Yrow_Z(gooddices) ;
% numoutputs = length(Yrow_Z)
% X = X(:,gooddices) ;

%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%
% % % Step 3:  Perform regression
%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%


nfact2keep = rank(X) ;
[T,P,W,Wstar,U,b,C,Bpls,Bpls_star,Xhat,Yhat,R2X,R2Y]=...
    PLS_nipals(X,Y,nfact2keep);


Glabels ={
  'G_K_1',...
  'G_K_s',...
  'G_t_o',...
  'kNaCa',...
  'kappa_r_e_l',...
  'V_u_p',...
  'K_l_e_a_k',...
  }
  


figure
handle = gcf ;
set(handle,'Position',[20,20,900,750])
set(handle,'PaperPosition',[1 1 11 9.5]) ;
for i=1:length(Glabels)
    subplot(7,1,i)
    hold on
    plot(exp(Y(:,i)),exp(Yhat(:,i)),'ro')
    plotmin = min(min([exp(Y(:,i)),exp(Yhat(:,i))])) ;
    plotmax = max(max([exp(Y(:,i)),exp(Yhat(:,i))])) ;
    xlabel(['True G',Glabels{i}])
    ylabel(['Predicted G',Glabels{i}])
    axis([plotmin plotmax plotmin plotmax])
    plot([plotmin,plotmax],[plotmin,plotmax],'k:')
end

SSYT=sum((Y-ones(variations,1)*mean(Y)).^2);
SSYR=sum((Yhat-ones(variations,1)*mean(Y)).^2);
R2each=SSYR./SSYT

%%%%%%%%%%%%%%%%%
% % % Step 4:  Predict border zone conductances
%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%

Binverse=Bpls;

predictedX_Z = Yrow_Z*Binverse ;

muX=mean(Y) ;
sigmaX=std(Y) ;
% sigmaX = 0.15 ;
load conductances_many
% % % Equally bad no matter which normalization factors used
trueX_Z=(log(allparameters(dex,:)) - muX)./sigmaX ;
% trueX_Z=(log(conductances_BZ) - log(conductances_NZ))./sigmaX ;

trueX_log = trueX_Z.*sigmaX ;
predictedX_log = predictedX_Z.*sigmaX

% figure
% bar(1:length(Glabels),[trueX_Z',predictedX_Z'])
% set(gca,'TickDir','Out')
% xticklabel_rotate([1:length(Glabels)],90,Glabels,'Fontsize',10,'Interpreter','tex') ;
% 
% figure
% bar(1:length(Glabels),[trueX_log',predictedX_log'])
% set(gca,'TickDir','Out')
% xticklabel_rotate([1:length(Glabels)],90,Glabels,'Fontsize',10,'Interpreter','tex') ;

predictedX_norm = exp(predictedX_Z.*sigmaX) ;
trueX_norm = allparameters(dex,:)./allparameters(1,:) ;
% trueX_norm2 = exp(trueX_Z.*sigmaX) ;

figure
bar(1:length(Glabels),[trueX_norm',predictedX_norm'])
set(gca,'TickDir','Out')
xticklabel_rotate([1:length(Glabels)],90,Glabels,'Fontsize',10,'Interpreter','tex') ;

