% Ten Tusscher et al model
% Am J Physiol 286: H1573H1589, 2004.
% human ventricular cell 
% improved version of Priebe-Beucklemann
%    
%    t   time variable
%    V   membrane potantial

%% Maximum conductances of ionic currents
GNa_ = 14.838 ;               % nS/pF
GNab_ = 2.9e-4 ;              % nS/pF
PCa_ = 1.75e-4 ;              % cm3 uF-1 s-1 
GCab_ = 5.92e-4 ;             % nS/pF
Gto_ =  0.294 ;                % nS/pF
GKr_ = 0.096 ;                % nS/pF
GKs_ = 0.245 ;                % nS/pF
GK1_ = 5.405 ;                  % nS/pF
GpK_ = 0.0146 ;               % nS/pF
INaK_ = 1.362 ;                % pA/pF
kNaCa =  1000 ;                 % pA/pF
arel = 16.464 ;                 % uM/ms
crel = 8.232 ;                  % uM/ms
Vleak =  8e-5 ;                 % ms-1
Iup_ = 0.425 ;                 % uM/ms
GpCa_ = 0.025 ;               % nS/pF

conductances = [GNa_;GNab_;PCa_;GCab_;Gto_;GKr_;GKs_;GK1_;GpK_; ...
  INaK_;kNaCa;arel;crel;Vleak;Iup_;GpCa_] ;

baselineparameters = conductances;
n_parameters = length(baselineparameters);

sigmaG =  0.1;     % standard deviation for conductances

 variations = 300 ;

for ii=1:variations
 scaling = exp(sigmaG*randn(n_parameters,1)) ;
 newparams = scaling.*baselineparameters ;
 paramscell = num2cell(newparams) ;
 allparameters(:,ii) = newparams ;
      
end
  
save tnnp_fixed_params allparameters variations
